<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 3                                                  |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage CompatDB
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminCompatDBImport
 * A function to import CompatDB.org data from a CompatDB project mirror server
 * @author Philipp Louis Esselbach
 */
function AdminCompatDBImport()
{
	global $database, $preferences, $html, $security, $words_compatdb;
	@set_time_limit( 0 );
	$input_step = ( isset( $_GET[ 'input_step' ] ) ) ? $security -> checknum( $_GET[ 'input_step' ] ) : 0 ;
	$html -> makeheader( $words_compatdb[ 'IMPORT_NOW' ] );
	$html -> makesubheader();
	$html -> makegroupmenu( "compatdb" );
	$html -> makemainheader( $words_compatdb[ 'IMPORT_NOW' ], "import" );
	
	if( !$input_step )
	{
		$database -> dbquery( "TRUNCATE TABLE " . DB_PREFIX . "esselbach_ct_compatdb" );
		$database -> dbquery( "TRUNCATE TABLE " . DB_PREFIX . "esselbach_ct_compatdbentries" );
		$database -> dbquery( "TRUNCATE TABLE " . DB_PREFIX . "esselbach_ct_compatdbtags" );
		$database -> dbquery( "TRUNCATE TABLE " . DB_PREFIX . "esselbach_ct_compatdbvendors" );
		$database -> dbquery( "TRUNCATE TABLE " . DB_PREFIX . "esselbach_ct_compatdbos" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbcats SET compatdbcat_entries = '0', compatdbcat_products = '0'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbsubcats SET compatdbsubcat_entries = '0', compatdbsubcat_products = '0'" );
		echo $words_compatdb[ 'REMOVING_COMPATDB' ];
		echo "<br />";
		
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=1\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=1", 2000 );
		}
		elseif( $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=9\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=8", 2000 );
		}
		else
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=15\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=15", 2000 );
		}
	}
	
	if( $input_step == 1 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			if( $preferences[ 'compatdb_server' ] != "localhost" )
			{
				echo $words_compatdb[ 'DOWNLOADING' ] . " " . $words_compatdb[ 'NT_COMPATIBLE' ] . " " . $preferences[ 'compatdb_server' ] . " ... ";
				$data = compatdbget( "http://" . $preferences[ 'compatdb_server' ] . "/ntcompatible.compatdb" );
				
				if( isset( $data ) )
				{
					$done = compatdbwrite( "ntcompatible.compatdb", $data );
					
					if( $done )
					{
						echo "<a href=\"index.php?action=compatdbimport&amp;input_step=2\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
						$html -> jump( "index.php?action=compatdbimport&input_step=2", 2000 );
					}
					else
					{
						echo $words_compatdb[ 'CANNOT_WRITE' ] . "ntcompatible.compatdb<br /><br />" . $words_compatdb[ 'PLEASE_CHMOD_TO_777' ];
					}
				}
				else
				{
					echo $words_compatdb[ 'FAIL' ];
				}
			}
			else
			{
				if( file_exists( "compatdb/xmldata/ntcompatible.compatdb" ) )
				{
					echo $words_compatdb[ 'USING_LOCAL_COPY_OF' ] . " ntcompatible.compatdb<br />";
					echo "<a href=\"index.php?action=compatdbimport&amp;input_step=2\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
					$html -> jump( "index.php?action=compatdbimport&input_step=2", 2000 );
				}
				else
				{
					echo $words_compatdb[ 'NO_LOCAL_COPY_FOUND' ];
				}
			}
		}
	}
	
	if( $input_step == 2 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			$data = "";
			$file = fopen( "compatdb/xmldata/ntcompatible.compatdb", "r" );
			
			while ( !feof( $file ) ) 
			{
				$data .= fread( $file, 4096 );
			}
			
			fclose( $file );
			echo $words_compatdb[ 'PROCESSING_XML_DATA' ] . "<br />";
			
			if( $preferences[ 'website_charset' ] == "ISO-8859-1" or $preferences[ 'website_charset' ] == "UTF-8" or $preferences[ 'website_charset' ] == "US-ASCII" )
			{
				$xml = xml_parser_create( $preferences[ 'website_charset' ] );
			}
			else
			{
				$xml = xml_parser_create();
			}
			
			xml_set_element_handler( $xml, "compatdbstart", "compatdbend" );
			xml_set_character_data_handler( $xml, "compatdbparse" );
			xml_parse( $xml, $data );
			xml_parser_free( $xml );
			echo "<br />";
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=3\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=3", 2000 );
		}
	}
	
	if( $input_step == 3 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			echo $words_compatdb[ 'SYNCING_DATABASE' ] . "<br />";
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdb SET compatdb_list = '1' WHERE compatdb_list = '0'" );
			compatdbsync( 1 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=4\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=4", 2000 );
		}
	}
	
	if( $input_step == 4 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			echo $words_compatdb[ 'BUILDING_TAG_DATABASE' ] . "<br />";
			compatdbtags( 1 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=5\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=5", 2000 );
		}
	}
	
	if( $input_step == 5 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			echo $words_compatdb[ 'SYNCING_CATEGORIES' ] . "<br />";
			compatdbcatsync( 1 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=6\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=6", 2000 );
		}
	}
	
	if( $input_step == 6 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			echo $words_compatdb[ 'SYNCING_VENDORS' ] . "<br />";
			compatdbvendorsync( 1, "Windows" );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=7\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=7", 2000 );
		}
	}
	
	if( $input_step == 7 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "NT Compatible (Windows)" )
		{
			echo $words_compatdb[ 'SYNCING_OPERATING_SYSTEMS' ] . "<br />";
			compatdbossync( 1 );
		}
		
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=8\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=8", 2000 );
		}
		elseif( $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=15\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=15", 2000 );
		}
		else
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=22\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=22", 2000 );
		}
	}
	
	if( $input_step == 8 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			if( $preferences[ 'compatdb_server' ] != "localhost" )
			{
				echo $words_compatdb[ 'DOWNLOADING' ] . " " . $words_compatdb[ 'LINUX_COMPATIBLE' ] . " " . $preferences[ 'compatdb_server' ] . " ... ";
				$data = compatdbget( "http://" . $preferences[ 'compatdb_server' ] . "/linuxcompatible.compatdb" );
				
				if( isset( $data ) )
				{
					$done = compatdbwrite( "linuxcompatible.compatdb", $data );
					
					if( $done )
					{
						echo "<a href=\"index.php?action=compatdbimport&amp;input_step=9\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
						$html -> jump( "index.php?action=compatdbimport&input_step=9", 2000 );
					}
					else
					{
						echo $words_compatdb[ 'CANNOT_WRITE' ] . "linuxcompatible.compatdb<br /><br />" . $words_compatdb[ 'PLEASE_CHMOD_TO_777' ];
					}
				}
				else
				{
					echo $words_compatdb[ 'FAIL' ];
				}
			}
			else
			{
				if( file_exists( "compatdb/xmldata/linuxcompatible.compatdb" ) )
				{
					echo $words_compatdb[ 'USING_LOCAL_COPY_OF' ] . " linuxcompatible.compatdb<br />";
					echo "<a href=\"index.php?action=compatdbimport&amp;input_step=9\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
					$html -> jump( "index.php?action=compatdbimport&input_step=9", 2000 );
				}
				else
				{
					echo $words_compatdb[ 'NO_LOCAL_COPY_FOUND' ];
				}
			}
		}
	}
	
	if( $input_step == 9 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			$data = "";
			$file = fopen( "compatdb/xmldata/linuxcompatible.compatdb", "r" );
			
			while ( !feof( $file ) ) 
			{
				$data .= fread( $file, 4096 );
			}
			
			fclose( $file );
			echo $words_compatdb[ 'PROCESSING_XML_DATA' ] . "<br />";
			
			if( $preferences[ 'website_charset' ] == "ISO-8859-1" or $preferences[ 'website_charset' ] == "UTF-8" or $preferences[ 'website_charset' ] == "US-ASCII" )
			{
				$xml = xml_parser_create( $preferences[ 'website_charset' ] );
			}
			else
			{
				$xml = xml_parser_create();
			}
			
			xml_set_element_handler( $xml, "compatdbstart", "compatdbend" );
			xml_set_character_data_handler( $xml, "compatdbparse" );
			xml_parse( $xml, $data );
			xml_parser_free( $xml );
			echo "<br />";
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=10\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=10", 2000 );
		}
	}
	
	if( $input_step == 10 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo $words_compatdb[ 'SYNCING_DATABASE' ] . "<br />";
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdb SET compatdb_list = '2' WHERE compatdb_list = '0'" );
			compatdbsync( 2 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=11\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=11", 2000 );
		}
	}
	
	if( $input_step == 11 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo $words_compatdb[ 'BUILDING_TAG_DATABASE' ] . "<br />";
			compatdbtags( 2 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=12\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=12", 2000 );
		}
	}
	
	if( $input_step == 12 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo $words_compatdb[ 'SYNCING_CATEGORIES' ] . "<br />";
			compatdbcatsync( 2 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=13\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=13", 2000 );
		}
	}
	
	if( $input_step == 13 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo $words_compatdb[ 'SYNCING_VENDORS' ] . "<br />";
			compatdbvendorsync( 2, "Linux" );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=14\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=14", 2000 );
		}
	}
	
	if( $input_step == 14 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Linux Compatible (Linux)" )
		{
			echo $words_compatdb[ 'SYNCING_OPERATING_SYSTEMS' ] . "<br />";
			compatdbossync( 2 );
		}
		
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=15\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=15", 2000 );
		}
		else
		{
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=22\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=22", 2000 );
		}
	}
	
	if( $input_step == 15 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			if( $preferences[ 'compatdb_server' ] != "localhost" )
			{
				echo $words_compatdb[ 'DOWNLOADING' ] . " " . $words_compatdb[ 'MACOS_COMPATIBLE' ] . " " . $preferences[ 'compatdb_server' ] . " ... ";
				$data = compatdbget( "http://" . $preferences[ 'compatdb_server' ] . "/macoscompatible.compatdb" );
				
				if( isset( $data ) )
				{
					$done = compatdbwrite( "macoscompatible.compatdb", $data );
					
					if( $done )
					{
						echo "<a href=\"index.php?action=compatdbimport&amp;input_step=16\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
						$html -> jump( "index.php?action=compatdbimport&input_step=16", 2000 );
					}
					else
					{
						echo $words_compatdb[ 'CANNOT_WRITE' ] . "macoscompatible.compatdb<br /><br />" . $words_compatdb[ 'PLEASE_CHMOD_TO_777' ];
					}
				}
				else
				{
					echo $words_compatdb[ 'FAIL' ];
				}
			}
			else
			{
				if( file_exists( "compatdb/xmldata/macoscompatible.compatdb" ) )
				{
					echo $words_compatdb[ 'USING_LOCAL_COPY_OF' ] . " macoscompatible.compatdb<br />";
					echo "<a href=\"index.php?action=compatdbimport&amp;input_step=16\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
					$html -> jump( "index.php?action=compatdbimport&input_step=16", 2000 );
				}
				else
				{
					echo $words_compatdb[ 'NO_LOCAL_COPY_FOUND' ];
				}
			}
		}
	}
	
	if( $input_step == 16 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			$data = "";
			$file = fopen( "compatdb/xmldata/macoscompatible.compatdb", "r" );
			
			while ( !feof( $file ) ) 
			{
				$data .= fread( $file, 4096 );
			}
			
			fclose( $file );
			echo $words_compatdb[ 'PROCESSING_XML_DATA' ] . "<br />";
			
			if( $preferences[ 'website_charset' ] == "ISO-8859-1" or $preferences[ 'website_charset' ] == "UTF-8" or $preferences[ 'website_charset' ] == "US-ASCII" )
			{
				$xml = xml_parser_create( $preferences[ 'website_charset' ] );
			}
			else
			{
				$xml = xml_parser_create();
			}
			
			xml_set_element_handler( $xml, "compatdbstart", "compatdbend" );
			xml_set_character_data_handler( $xml, "compatdbparse" );
			xml_parse( $xml, $data );
			xml_parser_free( $xml );
			echo "<br />";
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=17\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=17", 2000 );
		}
	}
	
	if( $input_step == 17 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo $words_compatdb[ 'SYNCING_DATABASE' ] . "<br />";
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdb SET compatdb_list = '3' WHERE compatdb_list = '0'" );
			compatdbsync( 3 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=18\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=18", 2000 );
		}
	}
	
	if( $input_step == 18 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo $words_compatdb[ 'BUILDING_TAG_DATABASE' ] . "<br />";
			compatdbtags( 3 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=19\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=19", 2000 );
		}
	}
	
	if( $input_step == 19 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo $words_compatdb[ 'SYNCING_CATEGORIES' ] . "<br />";
			compatdbcatsync( 3 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=20\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=20", 2000 );
		}
	}
	
	if( $input_step == 20 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo $words_compatdb[ 'SYNCING_VENDORS' ] . "<br />";
			compatdbvendorsync( 3, "Mac OS" );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=21\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=21", 2000 );
		}
	}
	
	if( $input_step == 21 )
	{
		if( $preferences[ 'compatdb_lists' ] == $words_compatdb[ 'ALL' ] or $preferences[ 'compatdb_lists' ] == "Mac OS Compatible (Mac OS)" )
		{
			echo $words_compatdb[ 'SYNCING_OPERATING_SYSTEMS' ] . "<br />";
			compatdbossync( 3 );
			echo "<a href=\"index.php?action=compatdbimport&amp;input_step=22\">" . $words_compatdb[ 'NEXT' ] . " &gt;&gt;&gt;</a>";
			$html -> jump( "index.php?action=compatdbimport&input_step=22", 2000 );
		}
	}
	
	if( $input_step == 22 )
	{
		echo $words_compatdb[ 'IMPORT_COMPLETE' ];
	}
	
	$html -> maketablefooter();
	$html -> makesubfooter();
	$html -> makesubfooter();
}
/**
 * function compatdbget
 * A function to get the CompatDB.org data from a mirror server
 * @author Philipp Louis Esselbach
 */
function compatdbget( $url )
{
	if( function_exists( "curl_init" ) )
	{
		$compatdb = curl_init( $url );
		curl_setopt( $compatdb, CURLOPT_RETURNTRANSFER, 1 );
		curl_setopt( $compatdb, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
		$data = curl_exec( $compatdb );
		curl_close( $compatdb );
	}
	else
	{
		$compatdb = @fopen( $url, "r" );
		$data = "";
		while ( !feof( $compatdb ) ) 
		{
			$data .= fread( $compatdb, 4096 );
		}
		fclose( $compatdb );
	}
	
	return $data;
}
/**
 * function compatdbwrite
 * A function to write the CompatDB.org XML data to local compatdb.xml files
 * @author Philipp Louis Esselbach
 */
function compatdbwrite( $file, $data )
{
	$done = 0;
	$write = @fopen( "compatdb/xmldata/" . $file, "w" );
	
	if( $write )
	{
		fputs( $write, $data );
		fclose( $write );
		$done = 1;
	}
	
	return $done;
}
/**
 * function compatdbstart
 * A function to parse the header of CompatDB.org XML files
 * @author Philipp Louis Esselbach
 */
function compatdbstart( $parser, $name, $attrs )
{
	global $overview, $submission, $tag;
	
	if( $overview or $submission )
	{
		$tag = $name;
	}
	
	
	if( $name == "OVERVIEW" )
	{
		$overview = 1;
	}
	elseif( $name == "SUBMISSION" )
	{
		$submission = 1;
	}
}
/**
 * function compatdbparse
 * A function to parse CompatDB.org XML files
 * @author Philipp Louis Esselbach
 */
function compatdbparse( $parser, $data )
{
	global $tag, $overview, $product, $compatlink, $product_id, $vendor, $vendorlink, $category, $created, $modified, $submission, $permalink, $entry_id, $date, $author, $language, $os, $rating, $comment, $license;
	
	if( $overview )
	{
		
		if( $tag == "PRODUCT" )
		{
			$product .= $data;
		}
		elseif( $tag == "COMPATLINK" )
		{
			$compatlink .= $data;
		}
		elseif( $tag == "PRODUCT_ID" )
		{
			$product_id .= $data;
		}
		elseif( $tag == "VENDOR" )
		{
			$vendor .= $data;
		}
		elseif( $tag == "VENDORLINK" )
		{
			$vendorlink .= $data;
		}
		elseif( $tag == "CATEGORY" )
		{
			$category .= $data;
		}
		elseif( $tag == "CREATED" )
		{
			$created .= $data;
		}
		elseif( $tag == "MODIFIED" )
		{
			$modified .= $data;
		}
	}
	
	
	if( $submission )
	{
		
		if( $tag == "PERMALINK" )
		{
			$permalink .= $data;
		}
		elseif( $tag == "ENTRY_ID" )
		{
			$entry_id .= $data;
		}
		elseif( $tag == "DATE" )
		{
			$date .= $data;
		}
		elseif( $tag == "AUTHOR" )
		{
			$author .= $data;
		}
		elseif( $tag == "LANGUAGE" )
		{
			$language .= $data;
		}
		elseif( $tag == "OS" )
		{
			$os .= $data;
		}
		elseif( $tag == "RATING" )
		{
			$rating .= $data;
		}
		elseif( $tag == "COMMENT" )
		{
			$comment .= $data;
		}
		elseif( $tag == "LICENSE" )
		{
			$license .= $data;
		}
	}
}
/**
 * function compatdbend
 * A function to write the CompatDB.org data to the database
 * @author Philipp Louis Esselbach
 */
function compatdbend( $parser, $name )
{
	global $database, $system, $tag, $overview, $product, $compatlink, $product_id, $vendor, $vendorlink, $category, $created, $modified, $submission, $permalink, $entry_id, $date, $author, $language, $os, $rating, $comment, $license, $this_product, $entries;
	
	if( $name == "OVERVIEW" )
	{
		list( $cat, $subcat ) = explode( "/", $database -> xmlescape( $category ) );
		
		if( $cat == "Applications" )
		{
			$cat = 1;
			
			if( $subcat == "Business" )
			{
				$subcat = 1;
			}
			
			
			if( $subcat == "Development" )
			{
				$subcat = 2;
			}
			
			
			if( $subcat == "General" )
			{
				$subcat = 3;
			}
			
			
			if( $subcat == "Graphics" )
			{
				$subcat = 4;
			}
			
			
			if( $subcat == "Internet" )
			{
				$subcat = 5;
			}
			
			
			if( $subcat == "Multimedia" )
			{
				$subcat = 6;
			}
			
			
			if( $subcat == "Network" )
			{
				$subcat = 7;
			}
			
			
			if( $subcat == "Security" )
			{
				$subcat = 8;
			}
			
			
			if( $subcat == "Tools" )
			{
				$subcat = 9;
			}
			
			
			if( !is_numeric( $subcat ) )
			{
				$subcat = 3;
			}
		}
		
		
		if( $cat == "Games" )
		{
			$cat = 2;
			
			if( $subcat == "Action" )
			{
				$subcat = 10;
			}
			
			
			if( $subcat == "Adventure" )
			{
				$subcat = 11;
			}
			
			
			if( $subcat == "Arcade" )
			{
				$subcat = 12;
			}
			
			
			if( $subcat == "Boardgames" )
			{
				$subcat = 13;
			}
			
			
			if( $subcat == "General" )
			{
				$subcat = 14;
			}
			
			
			if( $subcat == "RPG" )
			{
				$subcat = 15;
			}
			
			
			if( $subcat == "Sports" )
			{
				$subcat = 16;
			}
			
			
			if( $subcat == "Strategy" )
			{
				$subcat = 17;
			}
			
			
			if( !is_numeric( $subcat ) )
			{
				$subcat = 14;
			}
		}
		
		
		if( $cat == "Hardware" )
		{
			$cat = 3;
			
			if( $subcat == "Audio" )
			{
				$subcat = 18;
			}
			
			
			if( $subcat == "Camera" )
			{
				$subcat = 19;
			}
			
			
			if( $subcat == "Controller" )
			{
				$subcat = 20;
			}
			
			
			if( $subcat == "General" )
			{
				$subcat = 21;
			}
			
			
			if( $subcat == "Input" )
			{
				$subcat = 22;
			}
			
			
			if( $subcat == "Motherboard" )
			{
				$subcat = 23;
			}
			
			
			if( $subcat == "Multimedia" )
			{
				$subcat = 24;
			}
			
			
			if( $subcat == "Network" )
			{
				$subcat = 25;
			}
			
			
			if( $subcat == "Printer" )
			{
				$subcat = 26;
			}
			
			
			if( $subcat == "Scanner" )
			{
				$subcat = 27;
			}
			
			
			if( $subcat == "Storage" )
			{
				$subcat = 28;
			}
			
			
			if( $subcat == "Video" )
			{
				$subcat = 29;
			}
			
			
			if( !is_numeric( $subcat ) )
			{
				$subcat = 21;
			}
		}
		
		$product_seo = $system -> doseo( $database -> xmlescape( $product ) );
		$created = str_replace( array( "T", "Z" ), array( " ", "" ), $database -> xmlescape( $created ) );
		$modified = str_replace( array( "T", "Z" ), array( " ", "" ), $database -> xmlescape( $modified ) );
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_compatdb (compatdb_id, compatdb_list, compatdb_category, compatdb_subcategory, compatdb_title, compatdb_seo, compatdb_description, compatdb_keywords, compatdb_tags, compatdb_vendor, compatdb_vendorlink, compatdb_vendorseo, compatdb_operatingsystems, compatdb_currentlink, compatdb_author, compatdb_lastauthor, compatdb_entries, compatdb_startdate, compatdb_enddate, compatdb_rating) VALUES ('" . $database -> xmlescape( $product_id ) . "', '0', '" . $cat . "', '" . $subcat . "', '" . $database -> xmlescape( $product ) . "', '" . $product_seo . "', '', '', '', '" . $database -> xmlescape( $vendor ) . "', '" . $database -> xmlescape( $vendorlink ) . "', '" . $system -> doseo( $database -> xmlescape( $vendor ) ) . "', '', '" . $database -> xmlescape( $compatlink ) . "', '', '', '0', '" . $database -> xmlescape( $created ) . "', '" . $database -> xmlescape( $modified ) . "', '0')" );
		$this_product = $product_id;
		$product_id = "";
		$product = "";
		$compatlink = "";
		$vendor = "";
		$vendorlink = "";
		$category = "";
		$created = "";
		$modified = "";
	}
	
	
	if( $name == "SUBMISSION" )
	{
		$comment_parsed = stripslashes( $database -> xmlescape( $comment ) );
		$comment_parsed = $system -> dechomp( $comment_parsed );
		$comment_parsed = $system -> code( $comment_parsed );
		$comment_parsed = $database -> dbescape( $comment_parsed );
		$date = str_replace( array( "T", "Z" ), array( " ", "" ), $database -> xmlescape( $date ) );
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_compatdbentries (compatdbentry_id, compatdbentry_product, compatdbentry_author, compatdbentry_os, compatdbentry_rawentry, compatdbentry_entry, compatdbentry_permalink, compatdbentry_license, compatdbentry_language, compatdbentry_date, compatdbentry_rating) VALUES ('" . $database -> xmlescape( $entry_id ) . "', '" . $database -> xmlescape( $this_product ) . "', '" . $database -> xmlescape( $author ) . "', '" . $database -> xmlescape( $os ) . "', '" . $database -> xmlescape( $comment ) . "', '" . $comment_parsed . "', '" . $database -> xmlescape( $permalink ) . "', '" . $database -> xmlescape( $license ) . "', '" . $database -> xmlescape( $language ) . "', '" . $date . "', '" . $database -> xmlescape( $rating ) . "')" );
		$entry_id = "";
		$permalink = "";
		$date = "";
		$author = "";
		$language = "";
		$os = "";
		$rating = "";
		$comment = "";
		$license = "";
	}
	
	$entries++;
	
	if( $entries == 100 )
	{
		echo ". ";
		flush();
		$entries = 0;
	}
}
/**
 * function compatdbsync
 * A function to sync the CompatDB.org stats in the database
 * @author Philipp Louis Esselbach
 */
function compatdbsync( $id )
{
	global $database, $system;
	$start_date = 0;
	$query = $database -> dbquery( "SELECT c2.compatdb_seo, c2.compatdb_title, c1.compatdbentry_product, c1.compatdbentry_author, c1.compatdbentry_os, c1.compatdbentry_entry, c1.compatdbentry_date, c1.compatdbentry_rating FROM " . DB_PREFIX . "esselbach_ct_compatdbentries c1, " . DB_PREFIX . "esselbach_ct_compatdb c2 WHERE c1.compatdbentry_product = c2.compatdb_id AND c2.compatdb_list = '" . $id . "' ORDER BY c1.compatdbentry_product" );
	
	while( list( $compatdb_seo, $compatdb_title, $compatdbentry_product, $compatdbentry_author, $compatdbentry_os, $compatdbentry_entry, $compatdbentry_date, $compatdbentry_rating ) = $database -> dbrow( $query ) )
	{
		if( $id == 1 )
		{
			$compatdb_seo .= "_windows";
		}
		elseif( $id == 2 )
		{
			$compatdb_seo .= "_linux";
		}
		elseif( $id == 3 )
		{
			$compatdb_seo .= "_macos";
		}
		
		if( !$start_date )
		{
			$start_date = $compatdbentry_date;
			$start_author = $compatdbentry_author;
			$entries = 0;
			$entries_text = "";
			$os = array();
			$ratings = array();
			$previous_compatdb_seo = "";
			$previous_compatdb_title = "";
			$previous_compatdbentry_product = "";
			$previous_compatdbentry_date = "";
			$previous_compatdbentry_author = "";
		}
		else
		{
			if( $compatdbentry_product != $previous_compatdbentry_product )
			{
				$end_date = $previous_compatdbentry_date;
				$last_author = $previous_compatdbentry_author;
				asort( $os );
				$os_entries_array = array();
				$previous_os = "";
				
				foreach( $os as $os_entry )
				{
					if( $os_entry != $previous_os )
					{
						$os_entries_array[ ] = $os_entry;
					}
					
					$previous_os = $os_entry;
				}
				
				$compatdb_operatingsystems = implode( ", ", $os_entries_array );
				$total_votes = count( $ratings );
				$total_rating = 0;
				
				foreach( $ratings as $rating )
				{
					$total_rating = $total_rating + $rating;
				}
				
				$compatdb_rating = $total_rating / $total_votes;
				$description = $database -> dbescape( $system -> description( $previous_compatdb_title . ". " . $entries_text ) );
				$keywords = $system -> keywords( $previous_compatdb_title . ". " . $entries_text );
				$tags = $system -> tags( $database -> dbescape( $previous_compatdb_title ) );
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdb SET compatdb_seo = '" . $previous_compatdb_seo . "', compatdb_description = '" . $description . "', compatdb_keywords = '" . $keywords . "', compatdb_tags = '" . $tags . "', compatdb_operatingsystems = '" . $compatdb_operatingsystems . "', compatdb_author = '" . $database -> dbescape( $start_author ) . "', compatdb_lastauthor = '" . $database -> dbescape( $last_author ) . "', compatdb_entries = '" . $entries . "', compatdb_startdate = '" . $start_date . "', compatdb_enddate = '" . $end_date . "', compatdb_rating = '" . $compatdb_rating . "' WHERE compatdb_id = '" . $previous_compatdbentry_product . "'" );
				$start_date = $compatdbentry_date;
				$start_author = $compatdbentry_author;
				$entries = 0;
				$entries_text = "";
				$os = array();
				$ratings = array();
			}
		}
		
		$os[ ] = $compatdbentry_os;
		$ratings[ ] = $compatdbentry_rating;
		$entries_text .= str_replace( "-", "", $compatdbentry_entry );
		$entries++;
		$previous_compatdb_seo = $compatdb_seo;
		$previous_compatdb_title = $compatdb_title;
		$previous_compatdbentry_product = $compatdbentry_product;
		$previous_compatdbentry_author = $compatdbentry_author;
		$previous_compatdbentry_date = $compatdbentry_date;
		$previous_compatdbentry_product = $compatdbentry_product;
		$previous_entries_text = $entries_text;
	}
	
	asort( $os );
	$os_entries_array = array();
	$previous_os = "";
	
	foreach( $os as $os_entry )
	{
		if( $os_entry != $previous_os )
		{
			$os_entries_array[ ] = $os_entry;
		}
		
		$previous_os = $os_entry;
	}
	
	$compatdb_operatingsystems = implode( ", ", $os_entries_array );
	$total_votes = count( $ratings );
	$total_rating = 0;
	
	foreach( $ratings as $rating )
	{
		$total_rating = $total_rating + $rating;
	}
	
	$compatdb_rating = $total_rating / $total_votes;
	$description = $database -> dbescape( $system -> description( $previous_compatdb_title . ". " . $previous_entries_text ) );
	$keywords = $system -> keywords( $previous_compatdb_title . ". " . $previous_entries_text );
	$tags = $system -> tags( $previous_compatdb_title );
	$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdb SET compatdb_seo = '" . $previous_compatdb_seo . "', compatdb_description = '" . $description . "', compatdb_keywords = '" . $keywords . "', compatdb_tags = '" . $tags . "', compatdb_operatingsystems = '" . $compatdb_operatingsystems . "', compatdb_author = '" . $database -> dbescape( $start_author ) . "', compatdb_lastauthor = '" . $database -> dbescape( $previous_compatdbentry_author ) . "', compatdb_entries = '" . $entries . "', compatdb_startdate = '" . $start_date . "', compatdb_enddate = '" . $previous_compatdbentry_date . "', compatdb_rating = '" . $compatdb_rating . "' WHERE compatdb_id = '" . $previous_compatdbentry_product . "'" );
}
/**
 * function compatdbtags
 * A function to build a CompatDB.org tags database
 * @author Philipp Louis Esselbach
 */
function compatdbtags( $id )
{
	global $database, $system;
	$query = $database -> dbquery( "SELECT compatdb_tags FROM " . DB_PREFIX . "esselbach_ct_compatdb WHERE compatdb_list = '" . $id . "'" );
	
	while( list( $tags ) = $database -> dbrow( $query ) )
	{
		if( $tags )
		{
			$tags = explode( ",", $database -> dbescape( $tags ) );
			
			foreach( $tags as $tag )
			{
				$tag_seo = $system -> doseo( $tag );
				$subquery = $database -> dbquery( "SELECT compatdbtag_id FROM " . DB_PREFIX . "esselbach_ct_compatdbtags WHERE compatdbtag_seo = '" . $tag_seo . "' AND compatdbtag_list = '" . $id . "'" );
				
				if( $database -> dbrows( $subquery ) )
				{
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbtags SET compatdbtag_count = compatdbtag_count + 1 WHERE compatdbtag_tag = '" . $tag . "' AND compatdbtag_list = '" . $id . "'" );
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_compatdbtags (compatdbtag_id, compatdbtag_list, compatdbtag_tag, compatdbtag_seo, compatdbtag_count) VALUES (NULL, '" . $id . "', '" . $tag . "', '" . $tag_seo . "', '1')" );
				}
			}
		}
	}
}
/**
 * function compatdbcatsync
 * A function to sync CompatDB.org categories
 * @author Philipp Louis Esselbach
 */
function compatdbcatsync( $id )
{
	global $database;
	$query = $database -> dbquery( "SELECT compatdb_category, compatdb_subcategory, compatdb_entries FROM " . DB_PREFIX . "esselbach_ct_compatdb WHERE compatdb_list = '" . $id . "'" );
	
	while( list( $compatdb_category, $compatdb_subcategory, $compatdb_entries ) = $database -> dbrow( $query ) )
	{
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbcats SET compatdbcat_products = compatdbcat_products + 1, compatdbcat_entries = compatdbcat_entries + '" . $compatdb_entries . "' WHERE compatdbcat_list = '" . $id . "' AND compatdbcat_category = '" . $compatdb_category . "'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbsubcats SET compatdbsubcat_products = compatdbsubcat_products + 1, compatdbsubcat_entries = compatdbsubcat_entries + '" . $compatdb_entries . "' WHERE compatdbsubcat_list = '" . $id . "' AND compatdbsubcat_subcategory = '" . $compatdb_subcategory . "'" );
	}
}
/**
 * function compatdbvendorsync
 * A function to sync CompatDB.org vendors
 * @author Philipp Louis Esselbach
 */
function compatdbvendorsync( $id, $osname )
{
	global $database, $system, $words_compatdb;
	$previous_vendor = "";
	$query = $database -> dbquery( "SELECT compatdb_category, compatdb_vendor, compatdb_entries FROM " . DB_PREFIX . "esselbach_ct_compatdb WHERE compatdb_list = '" . $id . "' ORDER BY compatdb_vendor" );
	
	while( list( $compatdb_category, $compatdb_vendor, $compatdb_entries ) = $database -> dbrow( $query ) )
	{
		if( $compatdb_category == 1 )
		{
			$compatdb_category_seo = " applications";
		}
		
		if( $compatdb_category == 2 )
		{
			$compatdb_category_seo = " games";
		}
		
		if( $compatdb_category == 3 )
		{
			$compatdb_category_seo = " hardware";
		}
		
		if( strtolower( $compatdb_vendor ) != strtolower( $previous_vendor ) )
		{
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_compatdbvendors (compatdbvendor_id, compatdbvendor_list, compatdbvendor_category, compatdbvendor_name, compatdbvendor_seo, compatdbvendor_description, compatdbvendor_keywords, compatdbvendor_products, compatdbvendor_entries) VALUES (NULL, '" . $id . "', '" . $compatdb_category . "', '" . $database -> dbescape( $compatdb_vendor ) . "', '" . $system -> doseo( $compatdb_vendor . $compatdb_category_seo ) . "', '" . $osname . " " . $words_compatdb[ 'COMPATIBILITY_RESULTS_FOR' ] . " " . $database -> dbescape( $compatdb_vendor ) . "', '" . $osname . ", " . $words_compatdb[ 'COMPATIBILITY_KEYWORDS' ] . "', '1', '" . $compatdb_entries . "')" );
		}
		else
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbvendors SET compatdbvendor_products = compatdbvendor_products + 1, compatdbvendor_entries = compatdbvendor_entries + " . $compatdb_entries . " WHERE compatdbvendor_name = '" . $database -> dbescape( $compatdb_vendor ) . "' AND compatdbvendor_list = '" . $id . "'" );
		}
		
		$previous_vendor = $compatdb_vendor;
	}
}
/**
 * function compatdbossync
 * A function to sync CompatDB.org operating systems
 * @author Philipp Louis Esselbach
 */
function compatdbossync( $id )
{
	global $database, $system, $words_compatdb;
	$query = $database -> dbquery( "SELECT compatdb_id, compatdb_category, compatdb_operatingsystems, compatdb_entries FROM " . DB_PREFIX . "esselbach_ct_compatdb WHERE compatdb_list = '" . $id . "'" );
	
	while( list( $compatdb_id, $compatdb_category, $compatdb_operatingsystems, $compatdb_entries ) = $database -> dbrow( $query ) )
	{
		if( $compatdb_category == 1 )
		{
			$compatdb_category_seo = " applications";
		}
		
		if( $compatdb_category == 2 )
		{
			$compatdb_category_seo = " games";
		}
		
		if( $compatdb_category == 3 )
		{
			$compatdb_category_seo = " hardware";
		}
		
		$compatdbentry_os_previous = "";
		$query2 = $database -> dbquery( "SELECT compatdbentry_os FROM " . DB_PREFIX . "esselbach_ct_compatdbentries WHERE compatdbentry_product = '" . $compatdb_id . "' ORDER BY compatdbentry_os" );
		
		while( list( $compatdbentry_os ) = $database -> dbrow( $query2 ) )
		{
			$query3 = $database -> dbquery( "SELECT compatdbos_id FROM " . DB_PREFIX . "esselbach_ct_compatdbos WHERE compatdbos_name = '" . $database -> dbescape( $compatdbentry_os ) . "' AND compatdbos_category = '" . $compatdb_category . "' AND compatdbos_list = '" . $id . "'" );
			
			if( !$database -> dbrows( $query3 ) )
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_compatdbos (compatdbos_id, compatdbos_list, compatdbos_category, compatdbos_name, compatdbos_seo, compatdbos_description, compatdbos_keywords, compatdbos_products, compatdbos_entries) VALUES (NULL, '" . $id . "', '" . $compatdb_category . "', '" . $database -> dbescape( $compatdbentry_os ) . "', '" . $system -> doseo( $compatdbentry_os . $compatdb_category_seo ) . "', '" . $words_compatdb[ '_COMPATIBILITY_RESULTS_FOR' ] . " " . $database -> dbescape( $compatdbentry_os ) . "', '" . $database -> dbescape( $compatdbentry_os ) . ", " . $words_compatdb[ 'COMPATIBILITY_KEYWORDS' ] . "', '0', '0')" );
			}
			
			if( $compatdbentry_os != $compatdbentry_os_previous )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbos SET compatdbos_products = compatdbos_products + 1, compatdbos_entries = compatdbos_entries + 1 WHERE compatdbos_name = '" . $database -> dbescape( $compatdbentry_os ) . "' AND compatdbos_category = '" . $compatdb_category . "' AND compatdbos_list = '" . $id . "'" );
			}
			else
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_compatdbos SET compatdbos_entries = compatdbos_entries + 1 WHERE compatdbos_name = '" . $database -> dbescape( $compatdbentry_os ) . "' AND compatdbos_category = '" . $compatdb_category . "' AND compatdbos_list = '" . $id . "'" );
			}
			
			$compatdbentry_os_previous = $compatdbentry_os;
		}
	}
}
?>